package com.zd.laboratory.mapper;

import java.util.List;

import com.zd.laboratory.domain.LabHardware;
import com.zd.laboratory.domain.LabSensor;
import com.zd.laboratory.domain.vo.LabSensorVO;
import org.apache.ibatis.annotations.Param;

/**
 * 传感器Mapper接口
 *
 * @author zd
 * @date 2021-08-30
 */
public interface LabSensorMapper {
    /**
     * 查询传感器
     *
     * @param id 传感器主键
     * @return 传感器
     */
    public LabSensor selectLabSensorById(Long id);

    /**
     * 查询传感器
     *
     * @param id 传感器主键
     * @return 传感器
     */
    public List<LabSensor> selectSensorBySubIds(Long... id);

    /**
     * 查询传感器列表
     *
     * @param labSensor 传感器
     * @return 传感器集合
     */
    public List<LabSensorVO> selectLabSensorList(LabSensor labSensor);

    /**
     * 新增传感器
     *
     * @param labSensor 传感器
     * @return 结果
     */
    public int insertLabSensor(LabSensor labSensor);

    /**
     * 修改传感器
     *
     * @param labSensor 传感器
     * @return 结果
     */
    public int updateLabSensor(LabSensor labSensor);

    /**
     * 删除传感器
     *
     * @param id 传感器主键
     * @return 结果
     */
    public int deleteLabSensorById(Long id);

    /**
     * 批量删除传感器
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteLabSensorByIds(Long[] ids);


    /**
     * 根据ids查询传感器列表
     *
     * @param ids 传感器
     * @return 传感器集合
     */
    public List<LabSensorVO> selectLabSensorListByIds(Long[] ids);

    int updateStateByGatewayIds(@Param("gatewayIds") List<String> gatewayIds, @Param("code") int code);

    int updateStateBySenorIds(@Param("senorIds") List<String> senorIds,@Param("code") int code);

    int updateStateBySenorNotIds(@Param("senorIds") List<String> senorIds,@Param("subjectId") Long subjectId, @Param("code") int code);

    int updateStateOther(@Param("gatewayIds") List<String> gatewayIds, @Param("code") int code);

    int selectSensorCountBySubIds(@Param ("subjectId") Long subjectId);

    List<LabHardware> selectHardWareList(@Param ("gatewayNum") String gatewayNum);
}
